﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Policy;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Newtonsoft.Json;

namespace Syspeace.Detectors.Sample.ButtonDetectorTrigger {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {
        public MainWindow() {
            InitializeComponent();
        }

        private void ButtonNo_Click(object sender, RoutedEventArgs e) {
            Post(success:false);
        }

        private void ButtonYes_Click(object sender, RoutedEventArgs e) {
            Post(success:true);
        }

        private const string basePath = @"C:\sp_buttonDetector";

        private void Post(bool success) {
            var json = new PostJsonModel {IsSuccess = success, IPAddress = textBoxIP.Text, UserName = textBoxUser.Text, LuckyNumber = long.Parse(textBoxLuckyNumber.Text), Timestamp = DateTime.UtcNow };
            var jsonText = JsonConvert.SerializeObject(json);
            var fileName = System.IO.Path.Combine(basePath, DateTime.UtcNow.ToString("yyyy-MM-dd HHmmss") + "_" + Guid.NewGuid() + ".txt");
            File.WriteAllText(fileName, jsonText, Encoding.UTF8);
        }

        Regex nonDigits = new Regex(@"[^0-9]");

        private void TextBoxLuckyNumber_OnTextChanged(object sender, TextChangedEventArgs e) {
            var cleaned = nonDigits.Replace(textBoxLuckyNumber.Text, "");
            if (cleaned != "") {
                long lp;
                if (!long.TryParse(cleaned, out lp)) {
                    cleaned = long.MaxValue.ToString();
                }
            }
            if (cleaned != textBoxLuckyNumber.Text) {
                textBoxLuckyNumber.Text = cleaned;
            }
        }
    }

        [JsonObject(MemberSerialization.OptOut)]
        class PostJsonModel {
            public string IPAddress { get; set; }
            public string UserName { get; set; }
            public bool IsSuccess { get; set; }
            public long LuckyNumber { get; set; }
            public DateTime Timestamp { get; set; }
        }
}
