﻿<?php
/**
 * Plugin Name: Syspeace WordPress Reporter
 * Plugin URI: http://www.syspeace.com/start/
 * Description: Alerts Syspeace about all login attempts on the web page <strong>*REQUIRES THE SYSPEACE SOFTWARE AND A WINDOWS SERVER*</strong>
 * Version: 1.0.0
 * Author: Treetop Innovation AB
 * Author URI: http://www.treetop.se/
 * License: MIT
 */

add_action('wp_login_failed','AccessFail');
add_action('wp_login','AccessSuccess');
add_action('admin_menu', 'fwds_plugin_settings');

function fwds_plugin_settings() {
  add_menu_page('Syspeace.Wordpress.Reporter Settings', 'Syspeace Reporter Settings', 'administrator', 'fwds_settings', 'fwds_display_settings');
}
function fwds_display_settings() {

    $reportertoken = (get_option('syspeace_reportertoken') != '') ? get_option('syspeace_reportertoken') : '*reporter token*';

    $website = (get_option('syspeace_website') != '') ? get_option('syspeace_website') : '*website name*';
    $html = '</pre>
<div class="wrap"><form action="options.php" method="post" name="options">
<h2>Select Your Settings</h2>
' . wp_nonce_field('update-options') . '
<table class="form-table" width="100%" cellpadding="10">
<tbody>
<tr>
<td scope="row" align="left" width="115px">
 <label>Reporting Token:</label></td><td scope="row" align="left"><input type="text" name="syspeace_reportertoken" value="' . htmlentities($reportertoken) . '" style="width: 350px;"/></td>
</tr>
<tr>
<td scope="row" align="left" width="115px">
 <label>Website:</label></td><td scope="row" align="left"><input type="text" name="syspeace_website" value="' . htmlentities($website) . '" style="width: 350px;"/></td>
</tr>
</tbody>
</table>
 <input type="hidden" name="action" value="update" />

 <input type="hidden" name="page_options" value="syspeace_reportertoken,syspeace_website" />

 <input type="submit" name="Submit" value="Update" /></form></div>
<pre>
';

    echo $html;
}


const SYSPEACE_LOG_PORT = 60100;

function AccessFail($username)
{
	SyspeaceLogAccess($username, false);
}
function AccessSuccess($username)
{
	SyspeaceLogAccess($username, true);
}
function SyspeaceLogAccess($username, $success)
{

$IP = $_SERVER['REMOTE_ADDR'];

/*if($IP == "::1")
{
    $IP = "127.0.0.1";
}*/
$Website = (get_option('syspeace_website') != '') ? get_option('syspeace_website') : '';
	
$ReporterToken  = (get_option('syspeace_reportertoken') != '') ? get_option('syspeace_reportertoken') : '';

if(($success != true && $success != false) || $username === null)
{
	return;
}
$Time = strftime("%Y-%m-%d %H:%M:%S");

$UserName = $username.'';

$Success = $success;


$arr = array('IP' => $IP, 'Success' => $Success, 'UserName' => $UserName, 'UTCTimestamp' => $Time, 'ReportingToken' => $ReporterToken, 'WebSite' => $Website);
$JSONObject = json_encode($arr);
	$options = array(
	  'http' => array(
		'method'  => 'POST',
		'content' => $JSONObject,
		'header'=>  "Content-Type: application/json\r\n" .
					"Accept: application/json\r\n"
		)
	);

	$context  = stream_context_create( $options );
	$url = "http://localhost:".SYSPEACE_LOG_PORT."/report";

	$result = file_get_contents( $url, false, $context );
}
?>