﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Management;
using Syspeace.WebDetector.Reporter;
using System.Threading;

namespace Syspeace.Membership.Reporter
{
    public class SyspeaceReportWebEventProvider : WebEventProvider
    {
        public override void Flush()
        {
        }

        private static string _reportingToken = System.Web.Configuration.WebConfigurationManager.AppSettings["SyspeaceMembershipReportingToken"];

        public override void ProcessEvent(WebBaseEvent raisedEvent)
        {
            if (raisedEvent is WebAuthenticationFailureAuditEvent)
            {
                WebAuthenticationFailureAuditEvent fail = (WebAuthenticationFailureAuditEvent)raisedEvent;
                SyspeaceReporter.LogAccess(fail.NameToAuthenticate, false, fail.RequestInformation.UserHostAddress, _reportingToken);
            }
            else if (raisedEvent is WebAuthenticationSuccessAuditEvent)
            {
                WebAuthenticationSuccessAuditEvent success = (WebAuthenticationSuccessAuditEvent)raisedEvent;
                SyspeaceReporter.LogAccess(success.NameToAuthenticate, true, success.RequestInformation.UserHostAddress, _reportingToken);
            }
        }

        public override void Shutdown()
        {
        }
    }
}